<template>
    <div class="details_header_item" v-if="canShow">
        <span v-if="config.title" class="details_header_item__title">{{config.title}}:</span>
        <span class="details_header_item__value">
            <n-a v-if="!value && !isComplexLink" />
            <div v-else-if="isComplex">
                <a v-if="isComplexLink && linkContent && urlComplexValue" :href="urlComplexValue" target='_blank' class="link"> {{linkContent}}</a>
                <router-link v-else-if="isRoute" :to="routerLink" class="link">{{linkContent}}</router-link>
                <span v-else-if="showErrorComplexValue">{{errorComplexValue}}</span>
                <n-a v-else />
            </div>
            <span v-else>{{dynamicFilter(value)}}</span>
        </span>
    </div>
</template>

<script>
import { NoAnswer as NA } from '@bloomio/spa-admin-common/components';
import dynamicFilterMixin from '@/mixins/dynamicFilterMixin';

export default {
    name: 'DetailsHeaderItem',
    mixins: [dynamicFilterMixin],
    components: {
        NA,
    },
    props: {
        /** design config */
        config: {
            type: Object,
            required: false,
        },
        /** param id from server */
        id: {
            type: [String, Object],
            required: false,
        },
        /** param value from server */
        value: {
            type: [String, Number, Object],
            required: false,
        },
    },
    computed: {
        canShow: vm => !vm.config.conditions || Object.entries(vm.config.conditions).every(([name, val]) => {
            switch (name) {
            case 'hasServerParam':
                return (!vm.isComplex && vm.value) || (vm.isComplex && vm.value[val]);
            case 'vuexGetters':
                return this.$store.getters[val];
            default:
                return true;
            }
        }),
        isComplex: vm => vm.config.complex,
        isRoute: vm => vm.isComplex && vm.config.type === 'route' && vm.config.complex.routeName,
        routerLink: vm => ({ name: vm.config.complex.routeName, params: vm.routerParams }),
        routerParams: vm => (vm.config.complex.routeParams ? Object.entries(vm.config.complex.routeParams).reduce((acc, [k, v]) => {
            acc[k] = vm.value[v];
            return acc;
        }, {}) : null),
        isComplexLink: vm => vm.isComplex && vm.config.type === 'url' && (typeof vm.value === 'object' && vm.value !== null),
        showErrorComplexValue: vm => vm.errorComplexValue && vm.value !== null,
        errorComplexValue: vm => vm.config.complex.error_title,
        addUrlOnErrorValue: vm => vm.errorComplexValue && vm.config.complex.add_url_on_error,
        urlComplexValue: vm => vm.value[vm.config.complex.url],
        linkContent: (vm) => {
            const { content, filter } = vm.config.complex;
            let result = '';
            if (typeof content === 'string') {
                result = vm.dynamicFilter(vm.value[content], filter);
            } else {
                result = Object.keys(content).reduce((acc, key) => {
                    if (vm.value[key]) {
                        acc.push(vm.dynamicFilter(vm.value[key], (typeof content[key] === 'object') ? content[key].filter : null));
                    }
                    return acc;
                }, []).join(' ');
            }
            return (!result && vm.addUrlOnErrorValue) ? vm.errorComplexValue : result;
        },
    },
};
</script>

<style lang="stylus" scoped>
.details_header_item
    display: flex
    flex-wrap: wrap
    padding: 1rem 0

.details_header_item__title
    margin-right: 2rem
    font-weight: bolder
    color: $dark_gray

</style>
